using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Muell
{
	/// <summary>
	/// Zusammenfassung fr Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.NumericUpDown daysBack;
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Erforderlich fr die Windows Form-Designeruntersttzung
			//
			InitializeComponent();

			//
			// TODO: Fgen Sie den Konstruktorcode nach dem Aufruf von InitializeComponent hinzu
			//
		}

		/// <summary>
		/// Die verwendeten Ressourcen bereinigen.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
			this.button1 = new System.Windows.Forms.Button();
			this.daysBack = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.daysBack)).BeginInit();
			this.SuspendLayout();
			// 
			// button1
			// 
			this.button1.Enabled = false;
			this.button1.Location = new System.Drawing.Point(56, 64);
			this.button1.Name = "button1";
			this.button1.TabIndex = 2;
			this.button1.Text = "Go";
			this.button1.Click += new System.EventHandler(this.RequestButton_Click);
			// 
			// daysBack
			// 
			this.daysBack.Location = new System.Drawing.Point(96, 16);
			this.daysBack.Minimum = new System.Decimal(new int[] {
																	 1,
																	 0,
																	 0,
																	 0});
			this.daysBack.Name = "daysBack";
			this.daysBack.Size = new System.Drawing.Size(56, 20);
			this.daysBack.TabIndex = 1;
			this.daysBack.Value = new System.Decimal(new int[] {
																   10,
																   0,
																   0,
																   0});
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(24, 16);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(64, 23);
			this.label1.TabIndex = 2;
			this.label1.Text = "Days back:";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(184, 101);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.daysBack);
			this.Controls.Add(this.button1);
			this.Name = "Form1";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.daysBack)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Der Haupteinstiegspunkt fr die Anwendung.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private IESignal.HooksClass	eSignal			= new IESignal.HooksClass();
		private int					lExpectedHandle = 0;

		private void eSignal_OnBarsChanged(int lHandle)
		{
			if (lHandle == lExpectedHandle && eSignal.get_IsHistoryReady(lHandle) == 1)
			{
				int numBars = eSignal.get_GetNumBars(lHandle);
				if (numBars == 0)
					MessageBox.Show("OnBarsChanged: should not happen, numbars = 0");
//				eSignal.ReleaseHistory(lHandle);
			}
		}

		private void eSignal_OnBarsReceived(int lHandle)
		{
			if (lHandle == lExpectedHandle && eSignal.get_IsHistoryReady(lHandle) == 1)
			{
				int numBars = eSignal.get_GetNumBars(lHandle);
				if (numBars == 0 || numBars != (int) daysBack.Value)
					MessageBox.Show("OnBarsReceived: should not happen, numbars = " + numBars + " instead of " + (int) daysBack.Value);
				else
					MessageBox.Show("OnBarsReceived: got data, everything is ok");
			}
			else
				MessageBox.Show("OnBarsReceived: history is not yet ready");

//			eSignal.ReleaseHistory(lHandle);
		}

		private void eSignal_OnEntitledValid()
		{
			if (eSignal.IsEntitled == 1)
			{
				button1.Enabled = true;
				MessageBox.Show("Connected");
			} 
			else 
			{
				MessageBox.Show("Not entitled");
				return;
			} 
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			eSignal.SetApplication("trademagic");

			// clear any eSignal internal cache
			eSignal.ClearSymbolCache();
			eSignal.ReleaseAllHistory();
			eSignal.ReleaseAllTimeSales();

			eSignal.OnBarsChanged	+= new IESignal._IHooksEvents_OnBarsChangedEventHandler(eSignal_OnBarsChanged);
			eSignal.OnBarsReceived	+= new IESignal._IHooksEvents_OnBarsReceivedEventHandler(eSignal_OnBarsReceived);
			eSignal.OnEntitledValid	+= new IESignal._IHooksEvents_OnEntitledValidEventHandler(eSignal_OnEntitledValid);
		}

		private void RequestButton_Click(object sender, System.EventArgs e)
		{
			RequestHistory();
		}
		
		private void RequestHistory()
		{
			eSignal.ReleaseHistory(lExpectedHandle);
			lExpectedHandle = eSignal.get_RequestHistory("MSFT", "D", IESignal.barType.btBARS, (int) daysBack.Value, -1, -1);
			if (eSignal.get_IsHistoryReady(lExpectedHandle) == 1) 
			{
				eSignal_OnBarsReceived(lExpectedHandle);
			}
		}
	}
}
